// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'PageMngr.pas' rev: 6.00

#ifndef PageMngrHPP
#define PageMngrHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ExtCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Pagemngr
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TPageNotifyEvent)(bool Next);

typedef void __fastcall (__closure *TPageRequestEvent)(int CurrentPage, int &NewPage);

typedef TNotebook TPageOwner;
;

typedef TPage TPageItem;
;

#pragma option push -b-
enum TPageHistoryCommand { hcNone, hcAdd, hcBack, hcForward, hcGoto };
#pragma option pop

class DELPHICLASS TPageManager;
class DELPHICLASS TPageHistory;
class PASCALIMPLEMENTATION TPageHistory : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	int FCurrent;
	int FHistoryCapacity;
	void __fastcall SetCurrent(int Value);
	void __fastcall SetHistoryCapacity(int Value);
	int __fastcall GetPageIndex(int Index);
	
public:
	__fastcall TPageHistory(void);
	__fastcall virtual ~TPageHistory(void);
	void __fastcall AddPageIndex(int PageIndex);
	void __fastcall DeleteHistoryItem(int Index);
	void __fastcall ResetHistory(void);
	__property int Current = {read=FCurrent, write=SetCurrent, nodefault};
	__property int HistoryCapacity = {read=FHistoryCapacity, write=SetHistoryCapacity, nodefault};
	__property int PageIndexes[int Index] = {read=GetPageIndex};
};


class DELPHICLASS TPageProxy;
class PASCALIMPLEMENTATION TPageManager : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Extctrls::TNotebook* FPageOwner;
	Classes::TList* FPageProxies;
	bool FSetStartPage;
	bool FDestroyHandles;
	Controls::TControl* FButtons[2];
	Classes::TNotifyEvent FSaveBtnClick[2];
	bool FChangeHelpContext;
	TPageHistory* FPageHistory;
	bool FUseHistory;
	TPageHistoryCommand FHistoryCommand;
	TPageRequestEvent FOnGetPriorPage;
	TPageRequestEvent FOnGetNextPage;
	Classes::TNotifyEvent FOnCheckButtons;
	Classes::TNotifyEvent FOnCheckProxy;
	Classes::TNotifyEvent FOnPageChanged;
	void __fastcall SetPageOwner(Extctrls::TNotebook* Value);
	int __fastcall GetProxyIndex(const AnsiString PageName);
	void __fastcall AddProxy(TPageProxy* Proxy);
	void __fastcall RemoveProxy(TPageProxy* Proxy);
	void __fastcall DestroyProxies(void);
	void __fastcall PageEnter(int Page, bool Next);
	void __fastcall PageLeave(int Page, bool Next);
	void __fastcall PageShow(int Page, bool Next);
	void __fastcall PageHide(int Page, bool Next);
	void __fastcall PageChanged(void);
	bool __fastcall GetNextEnabled(void);
	bool __fastcall GetPriorEnabled(void);
	int __fastcall GetPageIndex(void);
	void __fastcall SetPageIndex(int Value);
	int __fastcall GetPageCount(void);
	AnsiString __fastcall GetPageName(int Index);
	AnsiString __fastcall FindFreePage();
	void __fastcall SetPageProxies(Classes::TList* Value);
	Controls::TControl* __fastcall GetButton(int Index);
	void __fastcall SetButton(int Index, Controls::TControl* Value);
	void __fastcall SetDestroyHandles(bool Value);
	void __fastcall SyncBtnClick(int Index, bool Sync);
	void __fastcall BtnClick(System::TObject* Sender);
	void __fastcall DormantPages(void);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation AOperation);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall ChangePage(bool Next);
	
public:
	__fastcall virtual TPageManager(Classes::TComponent* AOwner);
	__fastcall virtual ~TPageManager(void);
	void __fastcall CheckBtnEnabled(void);
	void __fastcall Resync(void);
	virtual int __fastcall GetPriorPageIndex(int Page);
	virtual int __fastcall GetNextPageIndex(int Page);
	void __fastcall NextPage(void);
	void __fastcall PriorPage(void);
	void __fastcall GotoHistoryPage(int HistoryIndex);
	void __fastcall SetPage(int NewPageIndex, bool Next);
	__property AnsiString PageNames[int Index] = {read=GetPageName};
	__property int PageCount = {read=GetPageCount, nodefault};
	__property int PageIndex = {read=GetPageIndex, nodefault};
	__property bool NextEnabled = {read=GetNextEnabled, nodefault};
	__property bool PriorEnabled = {read=GetPriorEnabled, nodefault};
	__property TPageHistory* PageHistory = {read=FPageHistory};
	__property TPageHistoryCommand HistoryCommand = {read=FHistoryCommand, write=FHistoryCommand, nodefault};
	__property Classes::TNotifyEvent OnCheckProxy = {read=FOnCheckProxy, write=FOnCheckProxy};
	
__published:
	__property Extctrls::TNotebook* PageOwner = {read=FPageOwner, write=SetPageOwner};
	__property Classes::TList* PageProxies = {read=FPageProxies, write=SetPageProxies};
	__property Controls::TControl* NextBtn = {read=GetButton, write=SetButton, index=1};
	__property Controls::TControl* PriorBtn = {read=GetButton, write=SetButton, index=0};
	__property bool SetStartPage = {read=FSetStartPage, write=FSetStartPage, default=1};
	__property bool DestroyHandles = {read=FDestroyHandles, write=SetDestroyHandles, default=0};
	__property bool UseHistory = {read=FUseHistory, write=FUseHistory, default=0};
	__property TPageRequestEvent OnGetPriorPage = {read=FOnGetPriorPage, write=FOnGetPriorPage};
	__property TPageRequestEvent OnGetNextPage = {read=FOnGetNextPage, write=FOnGetNextPage};
	__property Classes::TNotifyEvent OnCheckButtons = {read=FOnCheckButtons, write=FOnCheckButtons};
	__property Classes::TNotifyEvent OnPageChanged = {read=FOnPageChanged, write=FOnPageChanged};
};


class PASCALIMPLEMENTATION TPageProxy : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TPageManager* FPageManager;
	AnsiString FPageName;
	TPageNotifyEvent FOnEnter;
	TPageNotifyEvent FOnLeave;
	TPageNotifyEvent FOnShow;
	TPageNotifyEvent FOnHide;
	AnsiString __fastcall GetPageName();
	void __fastcall SetPageName(const AnsiString Value);
	void __fastcall SetPageManager(TPageManager* Value);
	void __fastcall PageEnter(bool Next);
	void __fastcall PageLeave(bool Next);
	void __fastcall PageShow(bool Next);
	void __fastcall PageHide(bool Next);
	
protected:
	DYNAMIC void __fastcall SetParentComponent(Classes::TComponent* Value);
	
public:
	__fastcall virtual TPageProxy(Classes::TComponent* AOwner);
	__fastcall virtual ~TPageProxy(void);
	DYNAMIC bool __fastcall HasParent(void);
	DYNAMIC Classes::TComponent* __fastcall GetParentComponent(void);
	__property TPageManager* PageManager = {read=FPageManager, write=SetPageManager};
	
__published:
	__property AnsiString PageName = {read=GetPageName, write=SetPageName};
	__property TPageNotifyEvent OnEnter = {read=FOnEnter, write=FOnEnter};
	__property TPageNotifyEvent OnLeave = {read=FOnLeave, write=FOnLeave};
	__property TPageNotifyEvent OnShow = {read=FOnShow, write=FOnShow};
	__property TPageNotifyEvent OnHide = {read=FOnHide, write=FOnHide};
};


class DELPHICLASS TPageHistoryItem;
class PASCALIMPLEMENTATION TPageHistoryItem : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	int Index;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TPageHistoryItem(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TPageHistoryItem(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint pageNull = 0xffffffff;

}	/* namespace Pagemngr */
using namespace Pagemngr;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// PageMngr
