// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RxQuery.pas' rev: 6.00

#ifndef RxQueryHPP
#define RxQueryHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <BdeUtils.hpp>	// Pascal unit
#include <rxStrUtils.hpp>	// Pascal unit
#include <DBTables.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <RTLConsts.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <BDE.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxquery
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TQueryOpenStatus { qsOpened, qsExecuted, qsFailed };
#pragma option pop

class DELPHICLASS TRxQuery;
class PASCALIMPLEMENTATION TRxQuery : public Dbtables::TQuery 
{
	typedef Dbtables::TQuery inherited;
	
private:
	bool FDisconnectExpected;
	Classes::TNotifyEvent FSaveQueryChanged;
	char FMacroChar;
	Db::TParams* FMacros;
	Classes::TStrings* FSQLPattern;
	bool FStreamPatternChanged;
	bool FPatternChanged;
	TQueryOpenStatus FOpenStatus;
	Db::TParams* __fastcall GetMacros(void);
	void __fastcall SetMacros(Db::TParams* Value);
	void __fastcall SetSQL(Classes::TStrings* Value);
	void __fastcall PatternChanged(System::TObject* Sender);
	HIDESBASE void __fastcall QueryChanged(System::TObject* Sender);
	void __fastcall RecreateMacros(void);
	void __fastcall CreateMacros(Db::TParams* List, const char * Value);
	void __fastcall Expand(Classes::TStrings* Query);
	Word __fastcall GetMacroCount(void);
	void __fastcall SetMacroChar(char Value);
	Classes::TStrings* __fastcall GetRealSQL(void);
	
protected:
	virtual void __fastcall InternalFirst(void);
	virtual Db::TGetResult __fastcall GetRecord(char * Buffer, Db::TGetMode GetMode, bool DoCheck);
	virtual void __fastcall Loaded(void);
	virtual Bde::hDBICur __fastcall CreateHandle(void);
	virtual void __fastcall OpenCursor(bool InfoQuery);
	virtual void __fastcall Disconnect(void);
	virtual void __fastcall PSExecute(void);
	virtual Db::TIndexDef* __fastcall PSGetDefaultOrder(void);
	virtual AnsiString __fastcall PSGetTableName();
	
public:
	__fastcall virtual TRxQuery(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxQuery(void);
	void __fastcall ExpandMacros(void);
	HIDESBASE void __fastcall ExecSQL(void);
	HIDESBASE void __fastcall Prepare(void);
	void __fastcall OpenOrExec(bool ChangeLive);
	void __fastcall ExecDirect(void);
	Db::TParam* __fastcall MacroByName(const AnsiString Value);
	__property Word MacroCount = {read=GetMacroCount, nodefault};
	__property TQueryOpenStatus OpenStatus = {read=FOpenStatus, nodefault};
	__property Classes::TStrings* RealSQL = {read=GetRealSQL};
	
__published:
	__property char MacroChar = {read=FMacroChar, write=SetMacroChar, default=37};
	__property Classes::TStrings* SQL = {read=FSQLPattern, write=SetSQL};
	__property Db::TParams* Macros = {read=GetMacros, write=SetMacros};
};


#pragma option push -b-
enum TRunQueryMode { rqOpen, rqExecute, rqExecDirect, rqOpenOrExec };
#pragma option pop

class DELPHICLASS TRxQueryThread;
class PASCALIMPLEMENTATION TRxQueryThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Dbtables::TBDEDataSet* FData;
	TRunQueryMode FMode;
	bool FPrepare;
	System::TObject* FException;
	void __fastcall DoHandleException(void);
	
protected:
	virtual void __fastcall ModeError(void);
	virtual void __fastcall DoTerminate(void);
	virtual void __fastcall Execute(void);
	virtual void __fastcall HandleException(void);
	
public:
	__fastcall TRxQueryThread(Dbtables::TBDEDataSet* Data, TRunQueryMode RunMode, bool Prepare, bool CreateSuspended);
public:
	#pragma option push -w-inl
	/* TThread.Destroy */ inline __fastcall virtual ~TRxQueryThread(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TScriptAction { saFail, saAbort, saRetry, saIgnore, saContinue };
#pragma option pop

typedef void __fastcall (__closure *TScriptErrorEvent)(System::TObject* Sender, Db::EDatabaseError* E, int LineNo, int StatementNo, TScriptAction &Action);

class DELPHICLASS TSQLScript;
class PASCALIMPLEMENTATION TSQLScript : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TStrings* FSQL;
	Db::TParams* FParams;
	TRxQuery* FQuery;
	bool FTransaction;
	bool FSemicolonTerm;
	bool FIgnoreParams;
	char FTerm;
	Classes::TNotifyEvent FBeforeExec;
	Classes::TNotifyEvent FAfterExec;
	TScriptErrorEvent FOnScriptError;
	AnsiString __fastcall GetSessionName();
	void __fastcall SetSessionName(const AnsiString Value);
	Dbtables::TSession* __fastcall GetDBSession(void);
	AnsiString __fastcall GetText();
	void __fastcall ReadParamData(Classes::TReader* Reader);
	void __fastcall WriteParamData(Classes::TWriter* Writer);
	Dbtables::TDatabase* __fastcall GetDatabase(void);
	AnsiString __fastcall GetDatabaseName();
	void __fastcall SetDatabaseName(const AnsiString Value);
	void __fastcall CreateParams(Db::TParams* List, const char * Value);
	void __fastcall QueryChanged(System::TObject* Sender);
	void __fastcall SetQuery(Classes::TStrings* Value);
	void __fastcall SetParamsList(Db::TParams* Value);
	unsigned __fastcall GetParamsCount(void);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall CheckExecQuery(int LineNo, int StatementNo);
	virtual void __fastcall ExecuteScript(int StatementNo);
	
public:
	__fastcall virtual TSQLScript(Classes::TComponent* AOwner);
	__fastcall virtual ~TSQLScript(void);
	void __fastcall ExecSQL(void);
	void __fastcall ExecStatement(int StatementNo);
	Db::TParam* __fastcall ParamByName(const AnsiString Value);
	__property Dbtables::TSession* DBSession = {read=GetDBSession};
	__property AnsiString Text = {read=GetText};
	__property Dbtables::TDatabase* Database = {read=GetDatabase};
	__property unsigned ParamCount = {read=GetParamsCount, nodefault};
	
__published:
	__property AnsiString DatabaseName = {read=GetDatabaseName, write=SetDatabaseName};
	__property bool IgnoreParams = {read=FIgnoreParams, write=FIgnoreParams, default=0};
	__property bool SemicolonTerm = {read=FSemicolonTerm, write=FSemicolonTerm, default=1};
	__property AnsiString SessionName = {read=GetSessionName, write=SetSessionName};
	__property char Term = {read=FTerm, write=FTerm, default=47};
	__property Classes::TStrings* SQL = {read=FSQL, write=SetQuery};
	__property Db::TParams* Params = {read=FParams, write=SetParamsList, stored=false};
	__property bool Transaction = {read=FTransaction, write=FTransaction, nodefault};
	__property Classes::TNotifyEvent BeforeExec = {read=FBeforeExec, write=FBeforeExec};
	__property Classes::TNotifyEvent AfterExec = {read=FAfterExec, write=FAfterExec};
	__property TScriptErrorEvent OnScriptError = {read=FOnScriptError, write=FOnScriptError};
};


//-- var, const, procedure ---------------------------------------------------
static const char DefaultMacroChar = '\x25';
static const char DefaultTermChar = '\x2f';
static const Shortint dbfExecScript = 0x3;
extern PACKAGE void __fastcall CreateQueryParams(Db::TParams* List, const char * Value, bool Macro, char SpecialChar, const Sysutils::TSysCharSet &Delims);

}	/* namespace Rxquery */
using namespace Rxquery;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxQuery
